"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var path = require('path');
const moveDirectory_1 = require("./commands/moveDirectory");
const patchFiles_1 = require("./commands/patchFiles");
exports.default = (vorpal) => {
    vorpal
        .command('patch', 'Patch Truffle Migrations')
        .action((args, callback) => {
        console.log('patching...');
        let sourceDirectory = path.resolve(__dirname, '../../contracts/');
        let destinationDirectory = path.resolve(__dirname, '../../../../../contracts/TransmuteFramework/');
        moveDirectory_1.add(sourceDirectory, destinationDirectory, (err) => {
            let sourceDirectory = path.resolve(__dirname, '../../test/');
            let destinationDirectory = path.resolve(__dirname, '../../../../../test/TransmuteFramework/');
            moveDirectory_1.add(sourceDirectory, destinationDirectory, (err) => {
                let patchTargetPath = path.resolve(__dirname, '../../../../../migrations/2_deploy_contracts.js');
                let transmuteMigrations = path.resolve(__dirname, '../../migrations/2_deploy_contracts.js');
                patchFiles_1.patchFiles(patchTargetPath, transmuteMigrations)
                    .then(() => {
                    callback();
                });
            });
        });
    });
    vorpal
        .command('unpatch', 'UnPatch Truffle Migrations')
        .action((args, callback) => {
        console.log('unpatching...');
        let destinationDirectory = path.resolve(__dirname, '../../../../../test/TransmuteFramework/');
        moveDirectory_1.remove(destinationDirectory, (err) => {
        });
        destinationDirectory = path.resolve(__dirname, '../../../../../contracts/TransmuteFramework/');
        moveDirectory_1.remove(destinationDirectory, (err) => {
            let patchFilePath = path.resolve(__dirname, '../../../../../migrations/2_deploy_contracts.js');
            let backupPath = path.resolve(__dirname, '../../../../../migrations/2_deploy_contracts.js.transmute.bak');
            patchFiles_1.unpatchFiles(patchFilePath, backupPath);
        });
    });
    return vorpal;
};
