"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const vorpal = require('vorpal')();
const TransmuteFramework_1 = require("../TransmuteFramework");
let { web3 } = TransmuteFramework_1.default.init();
console.log('\n👑   Transmute Framework   👑\n');
const index_1 = require("./Patch/index");
const index_2 = require("./TransmuteIpfs/index");
const api_1 = require("./EventStore/api");
index_1.default(vorpal);
index_2.default(vorpal);
api_1.default(vorpal);
vorpal
    .command('web3 [cmd]', 'A command line interface to web3')
    .autocomplete(['accounts'])
    .action((args, callback) => {
    web3.eth.getAccounts((err, addresses) => tslib_1.__awaiter(this, void 0, void 0, function* () {
        if (err) {
            throw err;
        }
        console.log('Accounts: \n' + addresses.join('\n'));
        callback();
    }));
});
vorpal
    .command('migrate', 'Wrapper around truffle migrate')
    .action((args, callback) => {
    console.log();
    console.log('🍄  Running Truffle Migrate ...');
    var exec = require('child_process').exec;
    exec('truffle migrate', (error, stdout, stderr) => {
        console.log();
        console.log(stdout);
        if (error !== null) {
            console.log('exec error: ' + error);
        }
        callback();
    });
});
vorpal
    .command('test', 'Wrapper around truffle test')
    .action((args, callback) => {
    console.log();
    console.log('🍄  Running Truffle Test ...');
    var exec = require('child_process').exec;
    exec('truffle test', (error, stdout, stderr) => {
        console.log();
        console.log(stdout);
        if (error !== null) {
            console.log('exec error: ' + error);
        }
        callback();
    });
});
vorpal
    .parse(process.argv);
