'use strict';
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const Common_1 = require("../Utils/Common");
const Reducer_1 = require("./Reducer");
const Permissions_1 = require("../Permissions/Permissions");
class Factory extends Permissions_1.Permissions {
    constructor(framework) {
        super(framework);
        this.framework = framework;
        this.createEventStore = (factory, fromAddress) => tslib_1.__awaiter(this, void 0, void 0, function* () {
            let tx = yield factory.createEventStore({
                from: fromAddress,
                gas: 4000000
            });
            let fsa = Common_1.getFSAFromEventArgs(tx.logs[0].args);
            return {
                events: [fsa],
                tx: tx
            };
        });
        this.getAllEventStoreContractAddresses = (factory, fromAddress) => tslib_1.__awaiter(this, void 0, void 0, function* () {
            let addresses = yield factory.getEventStores({
                from: fromAddress
            });
            return addresses;
        });
        this.getFactoryReadModel = (factory, fromAddress) => tslib_1.__awaiter(this, void 0, void 0, function* () {
            return this.framework.ReadModel.getCachedReadModel(factory, fromAddress, Reducer_1.readModel, Reducer_1.reducer);
        });
    }
}
exports.Factory = Factory;
