"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.readModel = {
    readModelStoreKey: '',
    readModelType: 'RBACFactory',
    contractAddress: '0x0000000000000000000000000000000000000000',
    lastEvent: null,
    model: {}
};
const updatesFromMeta = (meta) => {
    return {
        lastEvent: meta.id
    };
};
const handlers = {
    ['ES_CREATED']: (state, action) => {
        let updatesToModel = {
            model: Object.assign({ [action.payload.address]: {
                    created: action.meta.created,
                    owner: action.meta.txOrigin
                } }, state.model)
        };
        let updatesToMeta = updatesFromMeta(action.meta);
        return Object.assign({}, state, updatesToModel, updatesToMeta);
    },
};
exports.reducer = (state = exports.readModel, action) => {
    if (handlers[action.type]) {
        return handlers[action.type](state, action);
    }
    return state;
};
