import { ITransmuteFramework } from '../../TransmuteFramework';
import * as Common from '../Utils/Common';
export interface IPermissions {
    setAddressRole: (acc: any, fromAddress: string, targetAddress: string, targetRole: string) => Promise<any>;
    setGrant: (acc: any, fromAddress: string, role: string, resource: string, action: string, attributes: string[]) => Promise<any>;
    getGrant: (acc: any, fromAddress: string, index: number) => Promise<any>;
    canRoleActionResource: (acc: any, fromAddress: string, role: string, action: string, resource: string) => Promise<boolean>;
    getPermissionsReadModel: (acc: any, fromAddress: string) => Promise<Common.IReadModel>;
}
export declare class Permissions implements IPermissions {
    framework: ITransmuteFramework;
    constructor(framework: ITransmuteFramework);
    setAddressRole: (acc: any, fromAddress: any, targetAddress: string, targetRole: string) => Promise<{
        events: Common.IFSAEvent[];
        tx: any;
    }>;
    setGrant: (acc: any, fromAddress: string, role: string, resource: string, action: string, attributes: string[]) => Promise<{
        events: Common.IFSAEvent[];
        tx: any;
    }>;
    getGrant: (acc: any, fromAddress: any, index: number) => Promise<{
        role: any;
        resource: any;
        action: any;
        attributes: any;
    }>;
    canRoleActionResource: (acc: any, fromAddress: string, role: string, action: string, resource: string) => Promise<boolean>;
    getPermissionsReadModel(acc: any, fromAddress: string): Promise<any>;
}
