"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.readModel = {
    readModelStoreKey: '',
    readModelType: 'Permissions',
    contractAddress: '0x0000000000000000000000000000000000000000',
    lastEvent: null,
    model: {}
};
const updatesFromMeta = (meta) => {
    return {
        lastEvent: meta.id
    };
};
const handlers = {
    ['AC_ROLE_ASSIGNED']: (state, action) => {
        let updatesToModel = {
            model: {}
        };
        let updatesToMeta = updatesFromMeta(action.meta);
        return Object.assign({}, state, updatesToModel, updatesToMeta);
    },
    ['AC_GRANT_WRITTEN']: (state, action) => {
        if (!state.model[action.payload.grant.role]) {
            state.model[action.payload.grant.role] = {};
        }
        if (!state.model[action.payload.grant.role][action.payload.grant.resource]) {
            state.model[action.payload.grant.role][action.payload.grant.resource] = {};
        }
        if (!state.model[action.payload.grant.role][action.payload.grant.resource][action.payload.grant.action]) {
            state.model[action.payload.grant.role][action.payload.grant.resource][action.payload.grant.action] = action.payload.grant.attributes;
        }
        let updatesToModel = {
            model: Object.assign({ [action.payload.grant.role]: Object.assign({ [action.payload.grant.resource]: Object.assign({ [action.payload.grant.action]: action.payload.grant.attributes }, state.model[action.payload.grant.role][action.payload.grant.resource][action.payload.grant.action]) }, state.model[action.payload.grant.role][action.payload.grant.resource]) }, state.model)
        };
        let updatesToMeta = updatesFromMeta(action.meta);
        return Object.assign({}, state, updatesToModel, updatesToMeta);
    },
};
exports.reducer = (state = exports.readModel, action) => {
    if (handlers[action.type]) {
        return handlers[action.type](state, action);
    }
    return state;
};
