"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
class ReadModel {
    constructor(framework) {
        this.framework = framework;
        this.readModelGenerator = (readModel, reducer, events) => {
            events.forEach((event) => {
                readModel = reducer(readModel, event);
            });
            return readModel;
        };
        this.maybeSyncReadModel = (eventStore, fromAddress, readModel, reducer) => tslib_1.__awaiter(this, void 0, void 0, function* () {
            let eventCount = (yield eventStore.eventCount.call({
                from: fromAddress
            })).toNumber();
            return this.framework.Persistence.LocalStore.getItem(readModel.readModelStoreKey)
                .then((_readModel) => tslib_1.__awaiter(this, void 0, void 0, function* () {
                if (!_readModel) {
                    _readModel = readModel;
                }
                if (_readModel.lastEvent === eventCount) {
                    return readModel;
                }
                let startIndex = _readModel.lastEvent !== null ? _readModel.lastEvent + 1 : 0;
                let events = yield this.framework.EventStore.readFSAs(eventStore, fromAddress, startIndex);
                let updatedReadModel = this.readModelGenerator(_readModel, reducer, events);
                return this.framework.Persistence.LocalStore.setItem(updatedReadModel.readModelStoreKey, updatedReadModel);
            }));
        });
        this.getCachedReadModel = (eventStore, fromAddress, readModel, reducer) => tslib_1.__awaiter(this, void 0, void 0, function* () {
            readModel.contractAddress = eventStore.address;
            readModel.readModelStoreKey = `${readModel.readModelType}:${readModel.contractAddress}`;
            readModel = yield this.maybeSyncReadModel(eventStore, fromAddress, readModel, reducer);
            return readModel;
        });
    }
}
exports.ReadModel = ReadModel;
