export interface IRawEsCommand {
    EventType: string;
    KeyType: string;
    ValueType: string;
    Key: string;
    Value: string;
}
export interface IRawEsEvent extends IRawEsCommand {
    Id: any;
    TxOrigin: string;
    Created: any;
}
export interface IUnmarshalledEsCommand {
    eventType: string;
    keyType: string;
    valueType: string;
    key: any;
    value: any;
}
export interface IFSACommand {
    type: string;
    payload: any;
    meta?: any;
}
export interface IFSAEvent extends IFSACommand {
    meta: any;
}
export interface ITransaction {
    tx: string;
    receipt: any;
    logs: any[];
}
export interface ITransmuteCommandResponse {
    events: Array<IFSAEvent>;
    transactions: Array<ITransaction>;
}
export interface IReadModel {
    lastEvent: number;
    readModelType: string;
    readModelStoreKey: string;
    contractAddress: string;
    model: any;
}
export declare const toAscii: (value: any) => any;
export declare const grantItemFromEvent: (event: any) => {
    role: any;
    resource: any;
    action: any;
    attributes: any;
};
export declare const grantItemFromValues: (values: any) => {
    role: any;
    resource: any;
    action: any;
    attributes: any;
};
export declare const permissionFromCanRoleActionResourceValues: (values: any) => {
    granted: any;
    resource: any;
    attributes: string[];
    _: {
        role: any;
        resource: any;
        attributes: string[];
    };
};
export declare const hex2ipfshash: (hash: any) => any;
export declare const ipfs2hex: (ipfshash: any) => string;
export declare const convertValueToType: (_valueType: any, _value: any) => any;
export declare const getValueFromType: (type: any, value: any) => any;
export declare const guessTypeFromValue: (value: any) => "I" | "U" | "A" | "X" | "S";
export declare const marshal: (_eventType: any, _keyType: any, _valueType: any, _key: any, _value: any) => {
    eventType: any;
    keyType: any;
    valueType: any;
    key: any;
    value: any;
};
export declare const getUnmarshalledObjectFromValues: (_id: any, _txOrigin: any, _created: any, _eventType: any, _keyType: any, _valueType: any, _key: any, _value: any) => {
    id: any;
    txOrigin: any;
    created: any;
    eventType: any;
    keyType: any;
    valueType: any;
    key: any;
    value: any;
};
export declare const unmarshal: (eventArgs: any) => {
    id: any;
    txOrigin: any;
    created: any;
    eventType: any;
    keyType: any;
    valueType: any;
    key: any;
    value: any;
};
export declare const getFSAFromFlat: (flat: any) => {
    type: any;
    payload: {
        [x: number]: any;
    };
    meta: {
        id: any;
        created: any;
        txOrigin: any;
        keyType: any;
        valueType: any;
    };
};
export declare const getFSAFromEventValues: (_id: any, _txOrigin: any, _created: any, _eventType: any, _keyType: any, _valueType: any, _key: any, _value: any) => IFSAEvent;
export declare const getFSAFromEventArgs: (eventArgs: any) => IFSAEvent;
export declare const flatten: (data: any) => {};
export declare const unflatten: (data: Object) => Object;
