export interface IIpfsConfig {
    host: string;
    port: string;
    options: {
        protocol: any;
    };
}
export interface ITransmuteIpfs {
    ipfs: any;
    isObjectStore: boolean;
    config: IIpfsConfig;
    init: (config: IIpfsConfig) => ITransmuteIpfs;
    addFromFs: (path: string) => Promise<any>;
    addFromURL: (url: string) => Promise<any>;
    writeObject: (obj: any) => Promise<any>;
    readObject: (hash: string) => Promise<any>;
    statesToPatches: (states: any[]) => Promise<any>;
    patchesToHashes: (patches: any[]) => Promise<any>;
    hashesToPatches: (hashes: string[]) => Promise<any>;
    applyPatches: (obj: any, patches: any[]) => any;
    applyIPLDHashes: (obj: any, hashes: string[]) => Promise<any>;
    diff: (start: any, end: any) => any;
    patch: (target: any, patch: any) => any;
}
export declare class TransmuteIpfsSingleton implements ITransmuteIpfs {
    ipfs: any;
    isObjectStore: boolean;
    config: IIpfsConfig;
    init(config?: {
        host: string;
        port: string;
        options: {
            protocol: string;
        };
    }): this;
    addFromFs(folderPath: any, options?: {
        recursive: boolean;
        ignore: string[];
    }): Promise<{}>;
    addFromURL(url: any): Promise<{}>;
    writeBuffer(buffer: any): Promise<{}>;
    writeObject(obj: any): Promise<{}>;
    readBuffer(hash: any): Promise<{}>;
    readObject(path: any): Promise<{}>;
    statesToPatches(states: any): Promise<{}>;
    patchesToHashes(patches: any): Promise<{}>;
    hashesToPatches: (hashes: any) => Promise<{}[]>;
    applyPatches: (obj: any, patches: any) => any;
    applyIPLDHashes: (obj: any, hashes: any) => Promise<any>;
    patch: (target: any, patch: any) => any;
    diff: (start: any, end: any) => any;
}
export declare var TransmuteIpfs: TransmuteIpfsSingleton;
